31 March 2025
   [v3.7.0 - Revision 1]

     Change log:
        -Artwork: fix artwork download (fixed URL)
        -Artwork: Allow configurable download source for artwork (archive.org, same file layout than OPLM backups)

14 March 2025
   [v3.7.0 - Revision 0]

     Change log:
        -UI: Bump UI library wxwidgets from v3.0.5 (static link, monolithic library) to 3.2.6 (DLL, modular)
        -Install queue: Show install progress on the HDL Batch installer icon on the toolbar (thanks to newer wxwidgets)
        -PFS Filebrowser: Fixed a bug that caused that file transfers to the HDD always reported an error, even if everything went smooth
        -Installed game list: Add installed game count
        -HDD listing: Drop dependency of WMIC.EXE and start using WIN32 API. ensuring compatibility with win11 and beyond due to WMIC deprecation
        -Development: Drop Support for 32-Bits version of HDL Batch Installer due to toolchain limitations and limited time

10 September 2024
   [v3.6.0 - Revision 2]

     Change log:
        -HDDManager: Darker green for better readability (credits to @lottehime for the idea)
        -Update manager: added dedicated update information UI wich will download and display the changelog for the latest update

24 May 2024
   [v3.6.0 - Revision 1]

     Change log:
        -PFS Filebrowser: Fix logic to effectively ignore non PFS partitions, subpartitions and unknown entries inside PFS partitions
        -Game delete from game list: Game deletion via HDL Dump is deprecated. the UI option will remain, but will pop a message telling user to delete from partition manager
        -PFSShell backend: quick fix for avoiding false positives on unmount errors
        -new: Stop program startup if wxwidgets found another instance of HDL Batch installer running

23 May 2024
   [v3.6.0 - Revision 0]

     Change log:
        -__NEW__: builtin PFS Filebrowser
        -PFS Filebrowser: allow operating on both physical HDDs connected to the PC and Virtual Images (eg: HDD dump or PCSX2 Images)
        -UI: Added Icons for most menus, dialogs and popups
        -Install queue and installed game list: Display a disc icon on the list with unique colors for CD, DVD and dual layer images
        -install queue: Dont show a dialogue telling how many games were added to queue if no errors arised

13 March 2024
   [v3.5.1 - Revision 6]

     Change log:
        -New: German Translation by GeAd23 (www.github.com/GeAd23)
        -HDDManager: Avoid refreshing partition table if user did nothing inside the partition creation dialog

15 December 2023
   [v3.5.1 - Revision 5]

     Change log:
        -Partition mount: Close PFSShell HDD handler before opening mount UI

14 November 2023
   [v3.5.1 - Revision 4]

     Change log:
        -Game installation: Fix issue with games containing special chars (such as `á`)
        -Game failed installation message: tell user to check log if unhandled error arises
        -Game installation: on install error, try to retrieve windows API error if posible.

26 October 2023
   [v3.5.1 - Revision 3]

     Change log:
        -UI: Added missing titles to windows
        -Game install: Add warning about appropiate usage of ZSO
        -Game Extraction: Probe extracted game to check if its ZSO and change extension accordingly
        -Game deletion: Deprecate old game deletion and tell user to delete games from the included HDD manager
        -Languages: Add french to manual selection
        -Partition creation: Add tooltip with info in regard of appropiate partition name
        -install queue: Highlight ZSO games with blue text

30 September 2023
   [v3.5.1 - Revision 2]

     Change log:
        -MBR Rewrite: Add warning about what this operation does
        -Built-in Game title database: Updated

11 August 2023
   [v3.5.1 - Revision 1]

     Change log:
        -HDDManager: Fix bug wich denied creation of partitions with a `+` on its name
		-Installed game list: when list gets updated, any unused space will be assigned to game title column

26 July 2023
   [v3.5.1 - Revision 0]

     Change log:
        -UI: Add resizing capabilities to every dialog save credits and component error
        -HDDManager: Allow to disable game title display via configuration (enabled by default)
        -HDDManager: Dont display Sub-Partitions by default (also customizable on configuration)
        -ART Download: Dont display download gauge on fast download
        -ART Download: add option to perform connection to artwork download service without checking certificates

21 July 2023
   [v3.5.0 - Revision 3]

     Change log:
        -Program startup: If program is running for first time and OS is windows 11. warn about ransomware false positives caused due to RAW HDD I/O when reading PS2 HDDs

08 June 2023
   [v3.5.0 - Revision 2]

     Change log:
        -Partiton creation dialog: Added bussy cursor and messages in partition creation success or error
        -PFSShell Features: Blocked on 32bit compilations untill further notice (error during I/O corrupts HDD randomly)
        -Translation: Russian translation by @stanlapru
        -Translation: Korean translation by @DDinghoya
        -Dokan download link: Updated URL to latest release due to usage of newer pfsfuse

12 February 2023
   [v3.5.0 - Revision 1]

     Change log:
        -HDDManager: Fixed bug wich caused all games to display the title of the first game
        -File download: Added check to prevent writing on disk if internet connection or file existence on github can't be confirmed
        -HDDManager: Allow batch deletion of partitions (in this mode, system partitions deletion will be forbidden).
        -HDDManager: Forbid creation and deletion of partitions named `__extend`
        -HDD format menu: enable it by default and only disable if PFSShell init reported an error

08 February 2023
   [v3.5.0 - Revision 0]

     Change log:
        -Program core: Added `libps2hdd.dll` to allow usage of PFSShell features
        -__New Feature__: HDD format wizard. format your HDD into PS2 format with the basic partitions
        -__New Feature__: HDDManager. manage the partitions inside your HDD. view, creation and deletion are available. (now you can safely delete games from PC)
        -Windows manifest: Fixed manifest used on 32bits versions. it was calling a 64bit assembly. causing a program init failure
        -__New Feature__: MD5 hash check feature. calculate, copy and auto search on redump.org the hashes of the games that you're about to install

30 January 2023
   [v3.4.3 - Revision 1]

     Change log:
        -mount partition: Added support for dokan2, as it uses a different enviroment variable than it's predecesor...
        -windows embedded manifest: updated to support automatic request of admin privileges on startup
		-download package: icons will not be decompressed on package. HDL Batch Installer will decompress on boot. reducing package size

28 January 2023
   [v3.4.3 - Revision 0]

     Change log:
        -installed game list: sort games alphabetically
        -HDD size report: Use `toc` command instead of `hdl_toc`, reducing the wait time in ~1.2secs
        -HDD size report: add used space to report

10 January 2023
   [v3.4.2 - Revision 2]

     Change log:
        -HDD detection: Fixed out of bounds array acess on failed HDD accessing and added error message for APA_PARTITION_BROKEN
        -hdl_dump retcodes: Added them all as macros for more sane error handling

14 November 2022
   [v3.4.2 - Revision 1]

     Change log:
        -Game extraction: Fixed progress dialog calling bug, wich caused the program to halt
        -OPL Launcher: updated to latest version (removed debug colors!)
		-Translations: Added Korean to language selector

14 November 2022
   [v3.4.2 - Revision 0]

     Change log:
        -Added: Experimental game deletion (unstable and untested, user must enable it manually from settings)

07 November 2022
   [v3.4.1 - Revision 3]

     Change log:
        -UI: Added better rezizing and proportions to some UI elements
        -OPL launcher injection: Added Progress gauge
        -icon loader: Added Progress gauge
        -Game dumper: Added Progress gauge

06 November 2022
   [v3.4.1 - Revision 2]

     Change log:
        -Installation: Installation queue will be aborted if the "not enough space on HDD" error arises more than 3 times
        -ART Downloader: When using the "fast mode", the wait time between each game was increased from 3.9 secs to 5
        -installation: Added more recognized error codes
        -installation: Disable busy cursor when asking to download the icon package
        -installation: reorganized pre-install steps, user will no longer be asked to download icons if the queue is empty

02 November 2022
   [v3.4.1 - Revision 1]

     Change log:
        -Dokan Manager: Negate access to the menu if no PFS partitions are found
        -Installation loop: Don't mark retcode `-1073741819` as an error, since it seems to be a coding issue in HDL-Dump

27 October 2022
   [v3.4.1 - Revision 0]

     Change log:
        -Removed: Console clock, it was interferring with install return code

10 September 2022
   [v3.4.0 - Revision 0]

     Change log:
        -New Feature: Massive game transfer. copy all games from one HDD to another, or cherry pick from installed game list
        -Installation loop: Added clock to keep on log the elapsed milisecconds that each install took
        -General: Some Refactorization and code formatting

20 June 2022
   [v3.3.4 - Revision 0]

     Change log:
        -Data reporting: Added MD5 hash file to report string
        -Install list: Added new feature to context menu that allows calculating md5 hash of a game from the list, wich is displayed on dialog and program log
        -WNBD client: Removed custom wnbd driver files, download of such files will be available as a separate release asset soon (this is done because wnbd driver is not windows signed, therefore, it's recognized as malware)
        -Game file selector: Added support to load .zso files, however, an HDLDump update to support the installation of zso is still needed
        -Game file selector: Now the description of each option can be localized

11 May 2022
   [v3.3.3 - Revision 0]

     Change log:
        -UI: Added horizontal rules to install queue and installed game list
        -Icon package: add more icons by @Flygsand
        -installed games: Added Feature to manually load custom icon into installed game (mark several games to perform in batch mode)

24 April 2022
   [v3.3.2 - Revision 0]

     Change log:
        -Dokan Manager: Fixed bug when transferring ART to non '+' Prefixed partitions when OPL folder is not present
        -Data management: Fixed bug when selecting drives numerated larger than 9, fixes issue #29
        -Argumment passing: Fixed --stay-on-top argumment
        -Package: Updated hdl-dump that can read up to 25 HDD's instead of 16, fixes issue #28

01 April 2022
   [v3.3.1 - Revision 0]

     Change log:
        -Program Init: updated conditions for icon package download and extraction
        -Data collecting: Fix issue in wich users that agreed with data collection stopped sending data after updating package
        -Installation loop: updated logic to be a little less error prone
        -Installation system: Remove trailing whitespaces at the end of title before installing
        -Data processing: Adapt partition name obtainment to work with the commits I made into mainstream HDL-Dump (now OPL launcher injection will work on ALL games)
        -installed game list: Added manual OPL Launcher Injection
        -general code: refactors and commented code cleanup
        -download cleanup: updated script

25 February 2022
   [v3.3.0 - Revision 1]

     Change log:
        -Program Frame: the HDD Management tab had a widget ID that wasn't contiguous to the last one (cause there was an old tab that was removed) causing segmentation fault on frame construction
        -Program Frame Constructor: Refactored a few things...

21 February 2022
   [v3.3.0 - Revision 0]

     Change log:
        -Files download: Added switch to perform fast ART Download (debug output will be distorted during download)
        -MBR.KELF Injection: latest HDL-Dump changed the MBR injection command name, updated internal calls to support the new name
        -Game title database: Sync internal DB with public one
        -Dokan Manager: Enforce data writing on unmount command
        -__NEW__: Add support for NBD Server (Client bundled on program)
        -NBD Client: Added default IP setting to settings handler
        -New: Added dialog to manage the NBD client driver
        -game installation command: Normalize string to UTF-8 before executing
        -Dokan Manager: If the dokan enviroment variable can't be found the interface won't appear

07 January 2022
   [v3.2.1 - Revision 1]

     Change log:
        -initialization: Added missing memory cleanups
        -Installation Feature: Added the posibility to send information when program installs a game that isn't registered on the database
        -__Game title database__: __Added 398 new titles__
        -Config menu: The config dialog will reflect the current values of config file
        -Menu: Layout changes and some sizers added into remaining tabs

31 December 2021
   [v3.2.1 - Revision 0]

     Change log:
        -Installation: Enhanced installation process, now the cancel feature is actually worth using, since install queue won't be flushed after install loop ends
        -__NEW__:: Added a menu that reports wich games weren't installed and why, this will show up after install loop ends
        -Minor internal changes: A few fixes...

20 December 2021
   [v3.2.0 - Revision 0]

     Change log:
        -GUI: Minor fixes on frame sizers
        -__NEW__: Added support for PFSFUSE by alex parrado
        -PFSFUSE: Added OPL files automated transfer

22 November 2021
   [v3.1.3 - Revision 1]

     Change log:
        -OPL Launcher injection : Due to the new custom icon loader, `list.ico` will be deleted when KELF injection routine is called

16 November 2021
   [v3.1.3 - Revision 0]

     Change log:
        -Game Installation: Add custom icons loader (game ELF ID will be searched inside a INI file, if a matching entry is found, the asociated icon will be injected to the game)
        -Program startup: Fix a bug on some global variables initialization
        -Main Frame: add sizers in a very crude way

07 November 2021
   [v3.1.2 - Revision 1]

     Change log:
        -Init: Added missing error handling for No internet connection & errors when pulling latest version string from repository
        -Init: Migrate missing locale warning from wxLog to stdout (because it can't be skipped due to the boot logo being on top)
        -ART Download: Add batch script to delete files with 0 bytes in size (aka: files generated by wget when trying to download a file that doesn't exists

23 October 2021
   [v3.1.2 - Revision 0]

     Change log:
        -Initialization: Added update Checker
        -Program package: Added a local copy of HDLDump embedded icon
        -Settings menu: Add missing option for polish Language
        -Translation system: Addition of support for new languages made a litle bit easier
        -New: Database update feature (for logical reasons, this will only work for external DB)
        -New: Boot Splash

18 October 2021
   [v3.1.1 - Revision 1]

     Change log:
        -Database: Removed every (') from database (it was causing issues)
        -GUI: Re-attach event handler for game info context menu

18 October 2021
   [v3.1.1 - Revision 0]

     Change log:
        -Settings menu: Fixed bug related to settings writing (issue report #7 )
        -Settings menu: Enforce data writing before closing settings menu
        -New: Added MBR recovery feature
        -MBR recovery: Add warning if recovered KELF size is 0
        -GUI: Fixed some typos on localized strings (thanks haker120)

15 October 2021
   [v3.1.0 - Revision 1]

     Change log:
        -Locale: Add polish to supported language table

14 October 2021
   [v3.1.0 - Revision 0]

     Change log:
        -GUI: Re-sized main frame and re-organized layout on install and browse tabs
        -Installed game list: re-implement legacy data parsing (pre v3.0.4 - Revision 4) and maintain latest data parsing | latest style ensures compatibility with Winhiip, while legacy style ensured support for HDLGI, the usage on one or another will be determined by the presence of DMA mode (wich was absent on APA headers made by winhiip)

02 October 2021
   [v3.0.5 - Revision 4]

     Change log:
        -GUI: Fixed Graphical issues on installed game list (Code::Blocks editor showed the wxItemList inside the frame, but the real program had the list outside frame, wich caused graphical issues when casting context menus
        -Installed game context menu: GUI manifest didn't save properly, leaving the context menu for rename game detached from it's event handler... event has been succesfully re-attached (and maniffest was rewritten)

02 October 2021
   [v3.0.4 - Revision 4]

     Change log:
        -Data types: Revert some stupid shit that i did before public release (when I knew almost nothing about wxString containers)
        -Header Injection: Reversed KELF size check. (before: CMD.EXE did the dirty job | now: standard C++ is doing the dirty job)
        -Game title: Fixed filename obtainment if file extension is longer than 4 char('.???')

17 September 2021
   [v3.0.4 - Revision 1]

     Change log:
        -New: Context menu for Installation list
        -Installation list: Added "Remove from list" Option to context menu
        -Installation list: Added "Open File location" Option to context menu
        -Game extraction: Added newline character before console message "extracting game [%s]". it was erasing the elapsed time written by previous extraction (because of trailing /r left by hdldump)
        -Browse tab: Migrated the "Download", "Rename" and "extract" buttons into a new context menu (right click on installed game list)
        -Download manager: Fixed ART download

13 September 2021
   [v3.0.4 - Revision 0]

     Change log:
        -Installation command: Added warning message for error 110 (partition with such name exists)
        -Installation command: Added warning message and installation loop break for error 106 (not enough espace on HDD)
        -command line argumment: added a new commmand argumment that will force highest possible debug level (some sort of '--verbose' shit)

09 September 2021
   [v3.0.3 - Release]

     Change log:
        -Program startup: Added command line arguments support (arguments will be documented on github and batch file provided with the program
        -GUI: the GUI won't stay on top of other programs anymore (however, such behavior can be re-enabled by passing a command line argument)
        -Console: Added a console text redirection, when the specific command line argumment is provided, every text output that takes place after translation loading will be redirected into text files located on the 'logs' folder
        -Program calls: Replaced custom process redirection from the last two places where it was being used, now that module was completely removed...
        -Game list: Added compatibility to properly (i hope so) list games installed by outdated software

02 September 2021
   [v3.0.2 - Revision 0]

     Change log:
        -Header Injection: Added aborting if both KELF and icons are missing
        -Header Injection: Added size controls for KELF
        -Translation: Added support for Wxwidgets standard locale catalog (catalogs for currently supported languages will be bundled from now on)

27 August 2021
   [v3.0.0 - Revision 3]

     Change log:
        -New: External database lines that start with '#' will be skipped
        -Enhanced: Internal game title database parsing system

19 August 2021
   [v3.0.0 - Revision 2]

     Change log:
        -Enhanced: Installation command formatting
        -Added: A better alternative for real-time output redirection on installation command (text update is more fluid)
        -Added: Gamecount handler on game loading (if invalid game count is 0 the message won't say "discarded 0 invalid files")
        -New: Colorize partition table depending on partition type

19 August 2021
   [v3.0.0 - Revision 1]

     Change log:
        -Updated: Configurations handling
        -Updated: ART Downloader archive (before: OPLM Backup 2021/01 | now: 2021/07)
        -New: HDD Search button will be "focused" on program startup

27 July 2021
   [v3.0.0 - Revision 0]

     Change log:
        -Source code reformatted:
        -New: 32 bits build ( changes to both wxwidgets and HDLBinst  source code )
        -New: Credits tab will specify if program was built as 32 or 64 bits

26 July 2021
   [v2.9.0 - Revision 1]

     Change log:
        -Updated: Wildcard pattern order on game search dialog

25 July 2021
   [v2.9.0 - Revision 0]

     Change log:
        -Updated: Install loop
        -New: Massive game header injection.
        -New: when using mass header injection files that can be recognized by hdl-dump will be erased to avoid issues | only boot.kelf and icon files will be allowed
        -Fixed: Bug on HDD Update event, sometimes, certain features wheren't beeing re-activated after hdd update
        -Cleaned: Download manager Source code
        -Updated: Source code to remove unnecesary variables
        -Fixed: Minor issues on program startup

22 July 2021
   [v2.8.2 - Revision 4]

     Change log:
        -New: Replace OLD MiniOPL with latest OPL Launcher
        -Updated: MiniOPL update tool name and download URL

20 July 2021
   [v2.8.2 - Revision 3]

     Change log:
        -Added: CFG Download for games
        -Added: CHT Download from Widescreen hacks archive
        -Updated: Download manager (more efficiency)

20 July 2021
   [v2.8.2 - Revision 1]

     Change log:
        -Added: Checkbox to mark every ART type in 1 click
        -Fixed: weird bug on event handler for download button
        -New: When Only one PS2 HDD is found that HDD Is automatically selected
        -Added: Partition table display feature
	-Updated: HDD selection event
	-Updated: Program initialization
	-Fixed: Bug on language selector

20 July 2021
   [v2.8.0 - Revision 0]

     Change log:
        -Added: ART Download manager (direct from web archive, this feature is intended as an "emergency alternative" in case OPL Manager server is down)
        -Added: Minor front-end changes to HDD Browse tab
        -Removed: Unused code & front-end elements
	-Removed: Unused Translation Macro's

15 July 2021
   [v2.7.7 - Revision 2]

     Change log:
        -Added: Portuguese (br) support (translation by hardlevel)
        -Added: Minor front-end changes

11 July 2021
   [v2.7.7 - Revision 1]

     Change log:
        -Updated: Installation dialog will automatically close itself upon Installation loop end (thanks fabio gaigher)
        -Added: PFSShell interface for both formatting and partition creation [ALFA] (currently blocked for users)
        -Added: HDL Dump Update system

07 July 2021
   [2.7.7 - Revision 0]

     Change log:
        -Added: initialization flag to keep the GUI on top
        -Updated: Replace custom process redirection with wxwidgets standar process redirection (this affects installation and game rename)

04 July 2021
   [2.7.6 - Revision 3]

     Change log:
        -Updated: Installation Procedure
        -Updated: Missing language file warning (now it shows you the path where the program expects it to be)

02 July 2021
   [2.7.6 - Revision 2]

     Change log:
        -Added: MiniOPL Update trough wget
        -Updated: Credits menú layout (thanks FabioGaigher)

30 June 2021
   [2.7.6 - Revision 1]

     Change log:
        -Changed: Installation command string color from blue to bright white to improve readability, since it provides important info while debugging the installation process
        -Enhanced: Debug output to consola (reduce duplicated code)
        -Updated: Credits tab, re-organized elements and added "Translator section"

29 June 2021
   [2.7.6 - Revision 0]

     Change log:
        -Fixed: Language loading on startup

27 June 2021
   [2.7.5 - Revision 4]

     Change log:
        -Updated: PS2 HDD's Detection
        -Updated: Spanish Translation

27 June 2021
   [2.7.5 - Revision 2]

     Change log:
        -Added: Memory de-allocation for game rename dialog

25 June 2021
   [2.7.4 - Revision 6]

     Change log:
        -Added: Enhanced error handling when selecting HDD
        -Removed: HDD Selection event
        -Added: HDD Update event (this will reduce duplicated code)
        -Added:  Game list update event (this will reduce duplicated code)
        -Added: Game renaming Feature [BETA]

22 June 2021
   [2.7.4 - Revision 3]

     Change log:
        -Cleaned: Settings dialog startup
        -SRC Format: Whole project source code was reformatted
        -Updated: Stock HDLDump
        -Removed: Debug simbols
        -Reduced: Binary size (before: ~18Mb | now: ~9Mb)
        -Refactored: Configuration loading
	-Removed: Modify header wizard code (currently unused)

22 June 2021
   [2.7.4 - Revision 2]

     Change log:
        -Cleaned: initialization process and translation file loading

22 June 2021
   [2.7.4 - Revision 1]

     Change log:
	-Added: The changelog system that made the file you're reading now
        -Added: Error handling for unproperly connected HDD's
        -Added: Illegal characters filtering on game extraction
        -Updated: Translation system (string re-use)

